// C Header File
// Created 09/04/2003; 19:46:08

//default
setting set1=(setting){XMAX,YMAX,INIT_LEN,GROWTH,APPLE_NUM,BLOCK_NUM,APPLE_SIZE,BLOCK_SIZE,
						TIMER,STATS_ON,COMMAND_MODE,COMMAND_MODE2,VERMIS_NUM,HUMAN_NUM};

//1 player & 3 ia normal
setting set2=(setting){159/*XMAX*/,93/*YMAX*/,INIT_LEN,GROWTH,8/*APPLE_NUM*/,BLOCK_NUM,6/*APPLE_SIZE*/,BLOCK_SIZE,
						TIMER,STATS_ON,COMMAND_MODE,COMMAND_MODE2,4/*VERMIS_NUM*/,1/*HUMAN_NUM*/};

//
setting set3=(setting){XMAX,YMAX,INIT_LEN,GROWTH,APPLE_NUM,BLOCK_NUM,APPLE_SIZE,BLOCK_SIZE,
						TIMER,STATS_ON,COMMAND_MODE,COMMAND_MODE2,2/*VERMIS_NUM*/,2/*HUMAN_NUM*/};

//
setting set4=(setting){90/*XMAX*/,90/*YMAX*/,10/*INIT_LEN*/,7/*GROWTH*/,5/*APPLE_NUM*/,2/*BLOCK_NUM*/,APPLE_SIZE,BLOCK_SIZE,
						TIMER,STATS_ON,COMMAND_MODE,COMMAND_MODE2,VERMIS_NUM,HUMAN_NUM};

//0 player & 100 ia
setting set5=(setting){XMAX,YMAX,1/*INIT_LEN*/,1/*GROWTH*/,30/*APPLE_NUM*/,0/*BLOCK_NUM*/,APPLE_SIZE,BLOCK_SIZE,
						0/*TIMER*/,STATS_ON,COMMAND_MODE,COMMAND_MODE2,100/*VERMIS_NUM*/,0/*HUMAN_NUM*/};


void load_set(setting set){
	xmax = set.xmax;
	ymax = set.ymax;	
	init_len = set.init_len;
	growth = set.growth;	
	apple_num = set.apple_num;
	block_num = set.block_num;	
	apple_size = set.apple_size;
	block_size = set.block_size;
	timer = set.timer;	
	stats_on = set.stats_on;	
	command_mode = set.command_mode;
	command_mode2 = set.command_mode2;
	vermis_num = set.vermis_num;
	human_num = set.human_num;
	return;
}

void save_set(setting *set){
	(*set).xmax = xmax;
	(*set).ymax = ymax;	
	(*set).init_len = init_len;
	(*set).growth = growth;	
	(*set).apple_num = apple_num;
	(*set).block_num = block_num;	
	(*set).apple_size = apple_size;
	(*set).block_size = block_size;
	(*set).timer = timer;	
	(*set).stats_on = stats_on;	
	(*set).command_mode = command_mode;
	(*set).command_mode2 = command_mode2;	
	(*set).vermis_num = vermis_num;
	(*set).human_num = human_num;
	return;
}

void read_key(unsigned short *c, unsigned short *r){
	unsigned short i;
	*r = 31;
	while(_rowread(0));
	do{
		for(i=0;i<10;i++){
			if((*c = _rowread(~((unsigned short)1<<i)))&&(_rowread((unsigned short)1<<i)==0)){
				*r = i;
				break;
			}
		}
	}while(*r==31);
	for(i=0;i<8;i++){
		if(*c == (unsigned short)1<<i){
			*c = i;
			break;
		}
	}
	while(_rowread(0));
	return;
}

void p1_key_change(void){
	clrscr();
	FontSetSys(F_4x6);
	printf(P1_KEY_CHANGE);
	while(_rowread(0));
	printf(PRESS_UP_KEY);
	read_key(&u_p1_c,&u_p1_r);
	printf(PRESS_RIGHT_KEY);
	read_key(&r_p1_c,&r_p1_r);
	printf(PRESS_DOWN_KEY);
	read_key(&d_p1_c,&d_p1_r);
	printf(PRESS_LEFT_KEY);
	read_key(&l_p1_c,&l_p1_r);
	printf(P1_KEYS_CHANGED);
	while(_rowread(0)==0);
	return;
}

void p2_key_change(void){
	clrscr();
	FontSetSys(F_4x6);
	printf(P2_KEY_CHANGE);
	while(_rowread(0));
	printf(PRESS_UP_KEY);
	read_key(&u_p2_c,&u_p2_r);
	printf(PRESS_RIGHT_KEY);
	read_key(&r_p2_c,&r_p2_r);
	printf(PRESS_DOWN_KEY);
	read_key(&d_p2_c,&d_p2_r);
	printf(PRESS_LEFT_KEY);
	read_key(&l_p2_c,&l_p2_r);
	printf(P2_KEYS_CHANGED);
	while(_rowread(0)==0);
	return;
}

void menu1(void){
	while(1) {
		clrscr();
		FontSetSys(F_8x10);
		printf("- %s -\n",GAME_NAME);
		FontSetSys(F_4x6);
		printf("%s\n\n",EMAIL);
		printf(MENU_WIDTH,xmax);
		printf(MENU_HEIGHT,ymax);
		printf(MENU_INITIAL_LENGTH,init_len+1);
		printf(MENU_GROWTH_PER_APPLE,growth);
		printf(MENU_APPLE_NUM,apple_num);
		printf(MENU_APPLE_SIZE,apple_size);
		printf(MENU_BLOCKS_PER_APPLE,block_num);
		printf(MENU_BLOCK_SIZE,block_size);
		printf(MENU_CPU_VERMIS_NUM,vermis_num-human_num);
		printf(MENU_PRESS_ENTER_1);
		switch(ngetchx()){
			case KEY_RIGHT:
				xmax = (xmax - 2 * XMAX_MIN + XMAX_MAX + 2) % (XMAX_MAX - XMAX_MIN + 1) + XMAX_MIN;
				break;
				
			case KEY_LEFT:
				xmax = (xmax - 2 * XMAX_MIN + XMAX_MAX) % (XMAX_MAX - XMAX_MIN + 1) + XMAX_MIN;
				break;
			
			case KEY_DOWN:
				ymax = (ymax - 2 * YMAX_MIN + YMAX_MAX + 2) % (YMAX_MAX - YMAX_MIN + 1) + YMAX_MIN;
				break;
				
			case KEY_UP:
				ymax = (ymax - 2 * YMAX_MIN + YMAX_MAX) % (YMAX_MAX - YMAX_MIN + 1) + YMAX_MIN;
				break;
			
			case KEY_RIGHT+KEY_SHIFT:
				xmax = (xmax - 2 * XMAX_MIN + XMAX_MAX + 11) % (XMAX_MAX - XMAX_MIN + 1) + XMAX_MIN;
				break;
				
			case KEY_LEFT+KEY_SHIFT:
				xmax = (xmax - 2 * XMAX_MIN + XMAX_MAX - 9) % (XMAX_MAX - XMAX_MIN + 1) + XMAX_MIN;
				break;
			
			case KEY_DOWN+KEY_SHIFT:
				ymax = (ymax - 2 * YMAX_MIN + YMAX_MAX + 11) % (YMAX_MAX - YMAX_MIN + 1) + YMAX_MIN;
				break;
				
			case KEY_UP+KEY_SHIFT:
				ymax = (ymax - 2 * YMAX_MIN + YMAX_MAX - 9) % (YMAX_MAX - YMAX_MIN + 1) + YMAX_MIN;
				break;

			case 'y':
				init_len = (init_len - 2 + INIT_LEN_MAX) % INIT_LEN_MAX + 1;
				break;
			
			case 'z':
				init_len = (init_len + INIT_LEN_MAX) % INIT_LEN_MAX + 1;
				break;				
							
			case '(':
				growth = (growth - 1 + GROWTH_MAX) % GROWTH_MAX;
				break;
			
			case ')':
				growth = (growth + 1) % GROWTH_MAX;
				break;
			
			case '-':
				apple_num = (apple_num - 1 + APPLE_NUM_MAX) % APPLE_NUM_MAX;
				break;
			
			case '+':
				apple_num = (apple_num + 1) % APPLE_NUM_MAX;
				break;
			
			case '9':
				apple_size = (apple_size - 2 * APPLE_SIZE_MIN + APPLE_SIZE_MAX + 2) % (APPLE_SIZE_MAX - APPLE_SIZE_MIN + 1) + APPLE_SIZE_MIN;
				break;
			
			case ',':
				apple_size = (apple_size - 2 * APPLE_SIZE_MIN + APPLE_SIZE_MAX) % (APPLE_SIZE_MAX - APPLE_SIZE_MIN + 1) + APPLE_SIZE_MIN;
				break;
			
			case '/':
				block_num = (block_num - 1 + BLOCK_NUM_MAX) % BLOCK_NUM_MAX;
				break;
			
			case '*':
				block_num = (block_num + 1) % BLOCK_NUM_MAX;
				break;
			
			case '3':
				block_size = (block_size - 2 * BLOCK_SIZE_MIN + BLOCK_SIZE_MAX + 2) % (BLOCK_SIZE_MAX - BLOCK_SIZE_MIN + 1) + BLOCK_SIZE_MIN;
				break;
			
			case '6':
				block_size = (block_size - 2 * BLOCK_SIZE_MIN + BLOCK_SIZE_MAX) % (BLOCK_SIZE_MAX - BLOCK_SIZE_MIN + 1) + BLOCK_SIZE_MIN;
				break;
			
			case '|':
				vermis_num = (vermis_num + VERMIS_NUM_MAX - human_num + 1) % VERMIS_NUM_MAX + human_num;
				break;
			
			case '=':
				vermis_num = (vermis_num - 1 - human_num + VERMIS_NUM_MAX) % VERMIS_NUM_MAX + human_num;
				break;
						
			case KEY_ESC:
			case KEY_ENTER:
				menu2();
				return;
		}
	}

}

void menu2(void){
	while(1) {
		clrscr();
		FontSetSys(F_4x6);
		if(timer){
			printf(MENU_TIMER,(unsigned int)((unsigned long)timer*1000/395),395/timer);
		} else {
			printf(MENU_TIMER_IF_ZERO,(unsigned int)((unsigned long)timer*1000/395));
		}

		if(stats_on){
			printf(MENU_STATS_ON);
		} else {
			printf(MENU_STATS_OFF);
		}
		printf(MENU_HUMAN_NUM,human_num,vermis_num - human_num);
		if(human_num){
			if(command_mode){
				printf(MENU_P1_KEY_MODE_4,127);
			} else {
				printf(MENU_P1_KEY_MODE_2,127);
			}
		} else {
			printf(MENU_P1_KEY_MODE_INACTIVE);
		}
		if(human_num==2){
			if(command_mode2){
				printf(MENU_P2_KEY_MODE_4,127);
			} else {
				printf(MENU_P2_KEY_MODE_2,127);
			}
		} else {
			printf(MENU_P2_KEY_MODE_INACTIVE);
		}
		printf(MENU_HIGHSCORE,high_score);
		printf(MENU_RESET_DEFAULTS);
		printf(MENU_LOAD_SETTINGS);
		printf(MENU_SAVE_SETTINGS,127);
		printf(MENU_ARCHIVE_WARNING_LINE_1);
		printf(MENU_ARCHIVE_WARNING_LINE_2);
		printf(MENU_PRESS_BACSPACE);
		printf(MENU_PRESS_ENTER_2);
		switch(ngetchx()){
			case '-':
				timer = (timer - 1 + TIMER_MAX) % TIMER_MAX;
				break;
			
			case '+':
				timer = (timer + 1) % TIMER_MAX;
				break;
			
			case 'z':
				human_num = (human_num + 1)%3;
				if(human_num == 0){
					vermis_num -= 2;
				} else {
					vermis_num++;
				}
				break;
			
			case KEY_MODE:
				command_mode = (command_mode + 1)%2;
				break;
			
			case KEY_DIAMOND+KEY_MODE:
				p1_key_change();
				break;
			
			case KEY_APPS:
				command_mode2 = (command_mode2 + 1)%2;
				break;
			
			case KEY_APPS+KEY_DIAMOND:
				p2_key_change();
				break;
						
			case KEY_STO:
				stats_on = (stats_on + 1)%2;
				break;
			
			case KEY_CLEAR:
				high_score = 0;
				break;
						
			case KEY_F1:
				load_set(set1);
				break;
						
			case KEY_F2:
				load_set(set2);
				break;
						
			case KEY_F3:
				load_set(set3);
				break;
						
			case KEY_F4:
				load_set(set4);
				break;
						
			case KEY_F5:
				load_set(set5);
				break;
			
			case KEY_F2+KEY_DIAMOND:
				save_set(&set2);
				break;
						
			case KEY_F3+KEY_DIAMOND:
				save_set(&set3);
				break;
						
			case KEY_F4+KEY_DIAMOND:
				save_set(&set4);
				break;
						
			case KEY_F5+KEY_DIAMOND:
				save_set(&set5);
				break;
			
			case KEY_BACKSPACE:
				menu1();
				return;
						
			case KEY_ESC:
			case KEY_ENTER:
				clrscr();
				return;
		}
	}

}